program Sequenz;
{ Klaus Boremski
  DC3EH
  Reinhold-Klgel-Hof 50
  41812 Erkelenz

  Tel. 02431-806338
  DC3EH@T-Online.de }

{$NOSHADOW}
{ $S+ Stack check}         {switch not used}
{ $R+ Range check}         {switch not used}
{ $W+ Warnings}            {Warnings off}

Device = 90S2313;

Import SysTick, PWMPort1;

>From System Import ;

Define
        ProcClock   = 5000000;        {Hertz}
        SysTick     = 10;             {msec}
        StackSize   = $0020, iData;
        FrameSize   = $0010, iData;
        PWMpresc    = 8;
        PWMres      = 8;

Implementation

{$IDATA}

{--------------------------------------------------------------}
{ Type Declarations }

type


{--------------------------------------------------------------}
{ Const Declarations }
CONST
  MaxPttZaehler = 1000;

 { Var Declarations PORT }
{$PDATA}
VAR

   PortBOut [$38],PortBDir [$37], PortBPullUp [$36], PortBIn [$36] : BYTE;
   PortDOut [$32],PortDDir [$31], PortDPullUp [$30], PortDIn [$30] : BYTE;
(*
0073  0000             PIND            .EQU            030h            ; var Data   byte
0074  0000             DDRD            .EQU            031h            ; var Data   byte
0075  0000             PORTD           .EQU            032h            ; var Data   byte

0076  0000             PINB            .EQU            036h            ; var Data   byte
0077  0000             DDRB            .EQU            037h            ; var Data   byte
0078  0000             PORTB           .EQU            038h            ; var Data   byte
  *)

{--------------------------------------------------------------}
{ Var Declarations }
{$IDATA}

VAR
  StartPttZaehler, StopPttZaehler : INTEGER;
  Zeiteinheit, ZeitEinheit2, ZeitEinheit3, ZeitEinheit4 : INTEGER;
  Ptt, Flag1, Flag2, Flag3, MorseFlag : BOOLEAN;

  Ergebnis : BOOLEAN;
  I, J : INTEGER;


{--------------------------------------------------------------}
{ functions }

PROCEDURE Morse (Zeichen : WORD; StopMorse : Word);

BEGIN
  FOR I := 15 DOWNTO StopMorse DO
    IF (Zeichen AND $8000) = $8000
      THEN
        PWMPort1 := 128;
      ELSE
        PWMPort1 := 0;
    ENDIF;
    Zeichen := Zeichen SHL 1;
    MDelay (100);
  ENDFOR;
END;

FUNCTION NadelImpuls (VAR Merker : BOOLEAN; VAR Impuls : BOOLEAN; Modus : BYTE) : BOOLEAN;
{ ist nur f einen Durchlauf TRUE wenn
  der Impuls +1 bei ansteigender Flanke,
  der Impuls -1 bei abfallender Flanke,
  der Impuls 0 bei jeder Flanke }


BEGIN
  CASE Modus OF
    +1  : Ergebnis := Impuls AND (NOT Merker);   |
    $FF : Ergebnis := (NOT Impuls) AND Merker;   |
     0  : Ergebnis := Impuls <> Merker;          |
  ENDCASE;
  Merker := Impuls;
  Return (Ergebnis);
END;




{--------------------------------------------------------------}
{ Main Program }
{$IDATA}

begin
 PortDDir    := %00000000;
  PortDPullUp := %11111111;
  PortBDir    := %11111111;
 (* EnableInts;*)

  StartPttZaehler := 0;
  StopPttZaehler  := 0;
  MorseFlag := False;
  LOOP
  (*  SetBit (PortBOut, 0, Bit (PortDIn, 5));
    SetBit (PortBOut, 1, Bit (PortDIn, 4));
    SetBit (PortBOut, 2, Bit (PortDIn, 3));
   *)
    ZeitEinheit := 30;
    IF Bit (PortDIn, 1)
      THEN ZeitEinheit := ZeitEinheit + ZeitEinheit;
    ZeitEinheit2 := ZeitEinheit + ZeitEinheit;
    ZeitEinheit3 := ZeitEinheit + ZeitEinheit2;
    ZeitEinheit4 := ZeitEinheit2 + ZeitEinheit2;
    ENDIF;
    Mdelay (1);
    PTT := NOT Bit (PortDIn, 5);

    IF NadelImpuls (Flag1, Ptt, +1)
      THEN
     (*   Morse (%101010101010);*)
        IF NOT Bit (PortDIn, 2)
          THEN StartPttZaehler := ZeitEinheit;
          ELSE StartPttZaehler := 1;
        Endif;
        StopPttZaehler := 0;
         MorseFlag := False;
      ENDIF;

    IF NadelImpuls (Flag2, Ptt, $FF)
      THEN
(*       Morse (%111011101110);     *)
        StopPttZaehler := 1;
        StartPttZaehler := 0;
      ENDIF;

    IF (StartPttZaehler > 0) AND (StopPttZaehler = 0)
      THEN
        IF (StartPttZaehler > 0) AND (Bit (PortDIn, 2)) THEN SetBit (PortBOut, 7, TRUE); ENDIF;
        IF StartPttZaehler > ZeitEinheit  THEN SetBit (PortBOut, 6, TRUE); ENDIF;
        IF StartPttZaehler > ZeitEinheit2 THEN SetBit (PortBOut, 5, TRUE); ENDIF;
        IF StartPttZaehler > ZeitEinheit3 THEN
                                            SetBit (PortBOut, 4, TRUE);
                                            MorseFlag := True;
                                          ENDIF;
        IF StartPttZaehler < MaxPttZaehler THEN INC (StartPttZaehler); ENDIF;
      ENDIF;


     IF (StopPttZaehler > 0) AND (StartPttZaehler = 0)
      THEN
        IF (StopPttZaehler = 1) AND MorseFlag
          THEN
            IF (NOT Bit (PortDIn, 4)) AND (NOT Bit (PortDIn, 3))
              THEN
                Morse (%0111010111000000, 5);
              ELSE
                IF NOT Bit (PortDIn, 3) THEN Morse (%0111000000000000, 11); ENDIF;
                IF NOT Bit (PortDIn, 4) THEN Morse (%0100000000000000, 13); ENDIF;
              Endif;
          ENDIF;

        IF StopPttZaehler > ZeitEinheit4 THEN SetBit (PortBOut, 7, FALSE); ENDIF;
        IF StopPttZaehler > ZeitEinheit3 THEN SetBit (PortBOut, 6, FALSE); ENDIF;
        IF StopPttZaehler > ZeitEinheit2 THEN SetBit (PortBOut, 5, FALSE); ENDIF;
        IF StopPttZaehler > ZeitEinheit THEN SetBit (PortBOut, 4, FALSE); ENDIF;
        IF StopPttZaehler < MaxPttZaehler THEN INC (StopPttZaehler); ENDIF;
      ENDIF;


  ENDLOOP;

end Sequenz.


